require 'sylvilagus/init'
require 'sylvilagus/ch02'

require 'rabbitmq-client.jar'
import com.rabbitmq.client.ConnectionFactory

module Sylvilagus::Ch02::HelloWorld
  module ClassMethods
    def with_hello_world_conn(&block)
      factory = ConnectionFactory.new
      factory.setUri('amqp://guest:guest@localhost:5672')
      conn = factory.newConnection
      channel = conn.createChannel
      channel.exchangeDeclare('hello-exchange', 'direct', true)
      channel.queueDeclare('hello-queue', false, false, false, nil)

      block.call(conn, channel)
    ensure
      conn.close
    end
  end
end
